#property copyright "GOLDEN"
#property link      ""

#property indicator_chart_window

extern bool showPriceLabel = TRUE;
double G_ihigh_80;
double G_ilow_88;
double G_iopen_96;
double G_iclose_104;
double Gd_112;
double Gd_120;
double Gd_128;
double Gd_136;
double Gd_144;
double Gd_152;
double Gd_160;
double Gd_168;
double Gd_176;
double Gd_184;
double Gd_192;

int init() {
   return (0);
}

int deinit() {
   ObjectsDeleteAll(0, OBJ_TREND);
   ObjectsDeleteAll(0, OBJ_TEXT);
   return (0);
}

int start() {
   G_ihigh_80 = iHigh(NULL, PERIOD_D1, 1);
   G_ilow_88 = iLow(NULL, PERIOD_D1, 1);
   G_iopen_96 = iOpen(NULL, PERIOD_D1, 1);
   G_iclose_104 = iClose(NULL, PERIOD_D1, 1);
   Gd_112 = NormalizeDouble((G_ihigh_80 + G_ilow_88 + G_iclose_104) / 3.0, Digits);
   Gd_120 = NormalizeDouble(Gd_112 + 20.0 * Point, Digits);
   Gd_128 = NormalizeDouble(Gd_112 + 40.0 * Point, Digits);
   Gd_160 = NormalizeDouble(Gd_112 - 20.0 * Point, Digits);
   Gd_168 = NormalizeDouble(Gd_112 - 40.0 * Point, Digits);
   Gd_152 = NormalizeDouble(2.0 * Gd_112 + (G_ihigh_80 - 2.0 * G_ilow_88) + 5.0 * Point, Digits);
   Gd_192 = NormalizeDouble(2.0 * Gd_112 - (2.0 * G_ihigh_80 - G_ilow_88) - 5.0 * Point, Digits);
   Gd_144 = NormalizeDouble(Gd_112 + (G_ihigh_80 - G_ilow_88) + 5.0 * Point, Digits);
   Gd_184 = NormalizeDouble(Gd_112 - (G_ihigh_80 - G_ilow_88) - 5.0 * Point, Digits);
   Gd_136 = NormalizeDouble(Gd_120 + Gd_112 - G_ilow_88 - 5.0 * Point, Digits);
   Gd_176 = NormalizeDouble(Gd_160 + Gd_112 - G_ihigh_80 + 5.0 * Point, Digits);
   int datetime_0 = iTime(NULL, PERIOD_D1, 0);
   int datetime_4 = iTime(NULL, PERIOD_D1, 1);
   int datetime_8 = iTime(NULL, 0, 0);
   creatTrendLineObj2("[Golden MA] Line YH", datetime_4, G_ihigh_80, datetime_8, G_ihigh_80, Orange, 1, STYLE_DOT);
   createTextObj("[Golden MA] Text YH", datetime_4, G_ihigh_80, StringConcatenate("[Yesterday High]: ", G_ihigh_80));
   creatTrendLineObj2("[Golden MA] Line YL", datetime_4, G_ilow_88, datetime_8, G_ilow_88, Orange, 1, STYLE_DOT);
   createTextObj("[Golden MA] Text YL", datetime_4, G_ilow_88, StringConcatenate("[Yesterday Low]: ", G_ilow_88));
   creatTrendLineObj2("[Golden MA] Line YS", datetime_4, 0, datetime_4, 1, DarkGray, 1, STYLE_DOT);
   creatTrendLineObj2("[Golden MA] Line YE", datetime_0, 0, datetime_0, 1, DarkGray, 1, STYLE_DOT);
   creatTrendLineObj("[Golden MA] Line M", datetime_0, Gd_112, datetime_8, Gray, 5);
   creatTrendLineObj("[Golden MA] Line H1", datetime_0, Gd_120, datetime_8, DarkBlue, 5);
   creatTrendLineObj("[Golden MA] Line H2", datetime_0, Gd_128, datetime_8, DarkBlue, 5);
   creatTrendLineObj("[Golden MA] Line H3", datetime_0, Gd_136, datetime_8, DarkBlue, 5);
   creatTrendLineObj("[Golden MA] Line H4", datetime_0, Gd_144, datetime_8, DarkBlue, 5);
   creatTrendLineObj("[Golden MA] Line H5", datetime_0, Gd_152, datetime_8, DarkBlue, 5);
   creatTrendLineObj("[Golden MA] Line L1", datetime_0, Gd_160, datetime_8, Maroon, 5);
   creatTrendLineObj("[Golden MA] Line L2", datetime_0, Gd_168, datetime_8, Maroon, 5);
   creatTrendLineObj("[Golden MA] Line L3", datetime_0, Gd_176, datetime_8, Maroon, 5);
   creatTrendLineObj("[Golden MA] Line L4", datetime_0, Gd_184, datetime_8, Maroon, 5);
   creatTrendLineObj("[Golden MA] Line L5", datetime_0, Gd_192, datetime_8, Maroon, 5);
   if (showPriceLabel) {
      createTextObj("[Golden MA] Text M", datetime_0, Gd_112, StringConcatenate("[Middle Area]: ", Gd_112));
      createTextObj("[Golden MA] Text H1", datetime_0, Gd_120, StringConcatenate("[Buy Area] Start: ", Gd_120));
      createTextObj("[Golden MA] Text H2", datetime_0, Gd_128, StringConcatenate("[Buy Area] End: ", Gd_128));
      createTextObj("[Golden MA] Text H3", datetime_0, Gd_136, StringConcatenate("[Reversal High]: ", Gd_136));
      createTextObj("[Golden MA] Text H4", datetime_0, Gd_144, StringConcatenate("[WARNING! OVERBOUGHT]: ", Gd_144));
      createTextObj("[Golden MA] Text H5", datetime_0, Gd_152, StringConcatenate("[DANGER! STOP BUY HERE!]: ", Gd_152));
      createTextObj("[Golden MA] Text L1", datetime_0, Gd_160, StringConcatenate("[Sell Area] Start: ", Gd_160));
      createTextObj("[Golden MA] Text L2", datetime_0, Gd_168, StringConcatenate("[Sell Area] End: ", Gd_168));
      createTextObj("[Golden MA] Text L3", datetime_0, Gd_176, StringConcatenate("[Reversal Low]: ", Gd_176));
      createTextObj("[Golden MA] Text L4", datetime_0, Gd_184, StringConcatenate("[WARNING! OVERSOLD]: ", Gd_184));
      createTextObj("[Golden MA] Text L5", datetime_0, Gd_192, StringConcatenate("[DANGER! STOP SELL HERE!]: ", Gd_192));
   }
   for (int Li_12 = 1; Li_12 < 20; Li_12++) {
      creatTrendLineObj(StringConcatenate("[Golden MA] Line HH", Li_12), datetime_0, Gd_120 + Li_12 * Point, datetime_8, DarkBlue, 1);
      creatTrendLineObj(StringConcatenate("[Golden MA] Line LL", Li_12), datetime_0, Gd_168 + Li_12 * Point, datetime_8, Maroon, 1);
      creatTrendLineObj(StringConcatenate("[Golden MA] Line MH", Li_12), datetime_0, Gd_112 + Li_12 * Point, datetime_8, Gray, 1);
      creatTrendLineObj(StringConcatenate("[Golden MA] Line ML", Li_12), datetime_0, Gd_112 - Li_12 * Point, datetime_8, Gray, 1);
   }
   return (0);
}

void creatTrendLineObj(string A_name_0, int A_datetime_8, double A_price_12, int A_datetime_20, color A_color_24, int A_width_28) {
   ObjectDelete(A_name_0);
   ObjectCreate(A_name_0, OBJ_TREND, 0, A_datetime_8, A_price_12, A_datetime_20, A_price_12);
   ObjectSet(A_name_0, OBJPROP_BACK, TRUE);
   ObjectSet(A_name_0, OBJPROP_COLOR, A_color_24);
   ObjectSet(A_name_0, OBJPROP_WIDTH, A_width_28);
}

void creatTrendLineObj2(string A_name_0, int A_datetime_8, double A_price_12, int A_datetime_20, double A_price_24, color A_color_32, int A_width_36, int A_style_40) {
   ObjectDelete(A_name_0);
   ObjectCreate(A_name_0, OBJ_TREND, 0, A_datetime_8, A_price_12, A_datetime_20, A_price_24);
   ObjectSet(A_name_0, OBJPROP_BACK, TRUE);
   ObjectSet(A_name_0, OBJPROP_COLOR, A_color_32);
   ObjectSet(A_name_0, OBJPROP_WIDTH, A_width_36);
   ObjectSet(A_name_0, OBJPROP_STYLE, A_style_40);
}

void createTextObj(string A_name_0, int A_datetime_8, double A_price_12, string A_text_20) {
   ObjectDelete(A_name_0);
   ObjectCreate(A_name_0, OBJ_TEXT, 0, A_datetime_8, A_price_12);
   ObjectSetText(A_name_0, A_text_20, 8, "Arial", White);
}
